/* linear WAV  data ñ˷Ҥ
 * shige
 * 10/01 2000
 * wavconn.c
 *
 * $Id: wavconn.c,v 1.6 2000-10-15 17:03:11+09 shige Exp $
 */
#ifndef __WAVCONN_C__
#define __WAVCONN_C__

#include "wavconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,j0,k,N,inoption;
    char c;
    WAVdata wavdata[Maxdatanum];

    if(argc<2){ usage(); return Exit_noarg; }
    inithome(env);
    undefs="undefined";
    NULLFname=undefs;
    j=1;
    if(*argv[j]=='-'){
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2pathlist(argv[j])<0){
		    usage();
		    return Exit_addstr2pathlist;
		}
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(addstr2extlist(argv[j])<0){
		    usage();
		    return Exit_addstr2extlist;
		}
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		DEFAULTConffname=argv[j];
#if 0
		if(addfile2list(argv[j])<0){
		    usage();
		    return Exit_addfile2list;
		}
#endif /* 0 */
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    case 'n':
		if(*++argv[j]=='\0' && ++j>=argc){ usage(); return Exit_noarg; }
		if(*argv[j]=='-') NULLFname=NULL;
		else NULLFname=argv[j];
		inoption=0;
		break;
	    case 'h':
		usage(); return Exit_help;
	    default:
		usage(); return Exit_unknownarg;
	    }
	    if(inoption && (c=*(++argv[j]))!='\0') continue;
	    if(++j>=argc){ usage(); return Exit_noarg; }
	    if(*argv[j]!='-') break;
	    c=*(++argv[j]);
	}
    }
    if(initpathextlist(env)<0){
	usage();
	return Exit_envdefault;
    }
    if(listonly){
	for(k=j;k<argc;k++)
#ifdef USEFREOPEN
	  if((tmpfile1=fopenpathlist(argv[k],tmpfile1))!=NULL
	     ||(NULLFname!=NULL 
		&& (tmpfile1=fopenpathlist(NULLFname,tmpfile1))!=NULL)){
	      fclose(tmpfile1); tmpfile1=NULL;
	  }
#else
	  if((tmpfile1=fopenpathlist(argv[k]))!=NULL
	     ||(NULLFname!=NULL && (tmpfile1=fopenpathlist(NULLFname))!=NULL))
	    fclose(tmpfile1);
#endif
	return No_err;
    }
    j0=j;
    if(argc-1-j0+1>Maxdatanum){ usage(); return Exit_toomanyarg; }
    N=argc-1-j0+1;
    /* 1 ܤ file 򳫤 */
#ifdef USEFREOPEN
    if((tmpfile1=fopenpathlist(argv[j0],tmpfile1))==NULL){
	if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname,tmpfile1))==NULL)
#else
    if((tmpfile1=fopenpathlist(argv[j0]))==NULL){
	if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
#endif
	  return Exit_openpathfile;
	else argv[j0]=NULLFname;
    }
    if(getWAVheader(tmpfile1,&wavdata[0])<0) return Exit_getWAVheader;
#ifndef USEFREOPEN
    fclose(tmpfile1);
#endif
    if(wavdata[0].fmcode!=1) return Exit_unsupported_format;
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    for(j=2;j<=N;j++){
#ifdef USEFREOPEN
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL){ 
	    if(NULLFname==NULL
	       ||(tmpfile1=fopenpathlist(NULLFname,tmpfile1))==NULL)
#else
        if((tmpfile1=fopenpathlist(argv[j0+j-1]))==NULL){ 
	    if(NULLFname==NULL||(tmpfile1=fopenpathlist(NULLFname))==NULL)
#endif
	      return Exit_openpathfile;
	    else argv[j0+j-1]=NULLFname;
	}
	if(getWAVheader(tmpfile1,&wavdata[j-1])<0) return Exit_getWAVheader;
#ifndef USEFREOPEN
	fclose(tmpfile1);
#endif
	if(chWAVheader(&wavdata[j-1],&wavdata[0])<0) return Exit_chWAVheader;
    }
    /*  */
    putallWAVheader(stdout,wavdata,N);
    for(j=1;j<=N;j++){
#ifdef USEFREOPEN
	if((tmpfile1=fopenpathlist(argv[j0+j-1],tmpfile1))==NULL)
#else
	if((tmpfile1=fopenpathlist(argv[j0+j-1]))==NULL)
#endif
	  return Exit_openpathfile;
	putWAVdata(tmpfile1,stdout,wavdata[j-1].hlen,wavdata[j-1].datalen);
	fclose(tmpfile1);
#ifdef USEFREOPEN
	tmpfile1=NULL;
#endif
    }
    return No_err;
}

/* ########## usage ########## */
void usage(void)
{
    char *mess[]={
	"Usage: wavconn [options] [wavfile] ([wavfile] ...)",
	" options:",
	"   -p[path]: wavfile ѥ",
	"             (default= " DEF_Pathlist ")",
	"   -e[ext] : wavfile ĥ",
	"             (default= " DEF_Extlist ")",
	"   -f[file]: ե (default= " DEF_Conffname ")",
	"   -l      : wav file ΥꥹȤΤɽ",
	"   -n[path]: nullfile ե̾ (default=ʤ)",
	"   -q      : 顼ɽʤ",
	"   -h      : Υå",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ"
	"̵뤵롣",
	"     ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ"
	"ʣ",
	"     Ԥ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ " DEF_PathEnvname 
	", " DEF_ExtEnvname " ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ"
	"ץ",
	"     βս default: Ȥƽ񤫤Ƥ)",
	" [4] nullfile ϡꤷե뤬ʤäѤ˻Ȥ"
	"ե",
	"     (̵ʤ)ΥեФƤ⸡ѥĥҤ"
	"ͭ",
	"     default Ǥ nullfile ϻѤ顼Ȥ롣"
	"Ķѿ " DEF_NULLFEnvname " Ǥ",
	"     ꡢեǤΥ \"nullfile\" ˤġ",
	"     ʤե̾Ȥ \"-\" ꤷ nullfile "
	"Ѥʤ",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}

#endif /* __WAVCONN_C__ */
